.nolist	; copied from icztutes\tute09, with [url=+0]small changes[/url]
include \masm32\include\masm32rt.inc


ShowTheProblem = 1


WinMain	PROTO:DWORD,:DWORD,:DWORD,:DWORD

.data
ClassName	db "SimpleWinClass", 0
AppName	db "Our First Window", 0
MenuName	db "FirstMenu", 0
ButtonClassName	db "button", 0
ButtonText	db "Show clipboard", 0
EditClassName	db "edit", 0
TestString	db "Wow! I'm in an edit box now", 0

.data?
hInstance	HINSTANCE ?
CommandLine	LPSTR ?
hwndButton	HWND ?
hwndEdit	HWND ?
hStatic	HWND ?
buffer	db 512 dup(?)

.const
ButtonID	equ 1
EditID	equ 2
IDM_HELLO	equ 1
IDM_CLEAR	equ 2
IDM_GETTEXT	equ 3
IdStatic	equ 4
IDM_EXIT	equ VK_ESCAPE

.code
start:
	invoke GetModuleHandle, NULL
	mov hInstance, eax
	invoke GetCommandLine
	invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess, eax

WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
LOCAL hwnd:HWND
	mov wc.cbSize, SIZEOF WNDCLASSEX
	mov wc.style, CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc, OFFSET WndProc
	mov wc.cbClsExtra, NULL
	mov wc.cbWndExtra, NULL
	push hInst
	pop wc.hInstance
	mov wc.hbrBackground, COLOR_BTNFACE+1
	mov wc.lpszMenuName, OFFSET MenuName
	mov wc.lpszClassName, OFFSET ClassName
	invoke LoadIcon, NULL, IDI_APPLICATION
	mov wc.hIcon, eax
	mov wc.hIconSm, eax
	invoke LoadCursor, NULL, IDC_ARROW
	mov wc.hCursor, eax
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx, WS_EX_CLIENTEDGE, addr ClassName, addr AppName, 
		WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, 
		CW_USEDEFAULT, 300, 200, NULL, NULL, 
	hInst, NULL
	mov hwnd, eax
	invoke ShowWindow, hwnd, SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	.While TRUE
		invoke GetMessage, addr msg, NULL, 0, 0
		.Break .If eax==0
		invoke TranslateMessage, addr msg
		invoke DispatchMessage, addr msg
	.ENDW
	mov eax, msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	.If uMsg==WM_DESTROY
		invoke PostQuitMessage, NULL

	.ElseIf uMsg==WM_CREATE
		invoke CreateWindowEx, WS_EX_CLIENTEDGE, addr EditClassName, NULL, 
		WS_CHILD or WS_VISIBLE or WS_BORDER or ES_LEFT or ES_AUTOHSCROLL,
		50, 35+40, 200, 25, hWnd, EditID, hInstance, NULL
		mov hwndEdit, eax
		invoke SetWindowText, eax, chr$("Welcome")
		invoke SetFocus, hwndEdit
		invoke CreateWindowEx, NULL, addr ButtonClassName, addr ButtonText, 
		WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON, 
		75, 70+40, 140, 25, hWnd, ButtonID, hInstance, NULL
		mov hwndButton, eax
		invoke CreateWindowEx, NULL, chr$("static"), chr$("Copy something to the clipboard and click the button"),
			WS_CHILD or WS_VISIBLE or ES_LEFT, 3, 3, 200, 40,
			hWnd, IdStatic, hInstance, NULL
		mov hStatic, eax						; static window under buttons created

	.ElseIf uMsg==WM_COMMAND
		mov eax, wParam
		.If lParam==0
			.If ax==IDM_HELLO
				invoke SetWindowText, hwndEdit, addr TestString
				invoke SendMessage, hwndEdit, WM_KEYDOWN, VK_END, NULL
			.ElseIf ax==IDM_CLEAR
				invoke SetWindowText, hwndEdit, NULL
;			.ElseIf ax==IDM_GETTEXT
;				invoke GetWindowText, hwndEdit, addr buffer, 512
;				invoke MessageBox, NULL, addr buffer, addr AppName, MB_OK
			.Else
				invoke DestroyWindow, hWnd
			.Endif
		.Else
			.If ax==ButtonID
				shr eax, 16
				.If ax==BN_CLICKED
					if ShowTheProblem
						call GetClipboardText	; works only the first time
					else
						call GetClipboardText2	; works fine
					endif
					push ebx
					xchg eax, ebx
					.if ebx
						invoke SetWindowText, hStatic, ebx
						free ebx
					.else
						invoke SetWindowText, hStatic, chr$("FAILED")
					.endif
					pop ebx
				.Endif
			.Endif
		.Endif
	.Endif
	invoke DefWindowProc, hWnd, uMsg, wParam, lParam	; moved down here, different from icztutes\tute09
;	xor eax, eax
	ret
WndProc endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 
GetClipboardText2 proc	; \masm32\m32lib\getcbtxt.asm
	push ebx
	push esi
	push edi
	; --------------------------------------------------------
	; if the return value is not zero, deallocate the returned
	; memory handle with GlobalFree() or the macro "free" when
	; the data is no longer required.
	; --------------------------------------------------------
	invoke OpenClipboard, NULL	; open clipboard
	xor edi, edi	; flag success or failure
	.if rv(IsClipboardFormatAvailable, CF_TEXT)	; if text available
		invoke GetClipboardData, CF_TEXT	; get pointer to text
		xchg eax, ebx
		invoke GlobalLock, ebx	; needed - without, it fails the second time in non-console apps
		push eax
		invoke StrLen, eax	; get text length
		mov esi, eax
		mov edi, alloc(esi)	; allocate that much memory
		pop eax
		invoke szCopy, eax, edi
		invoke GlobalUnlock, ebx	; ShowTheProblem
	.endif
	invoke CloseClipboard	; close the clipboard
	xchg eax, edi	; zero or a pointer
	pop edi
	pop esi
	pop ebx
	retn
GetClipboardText2 endp

end start

RichMasm options:
OPT_Icon	Smiley		; see \Masm32\RichMasm\Icons
OPT_Res	GetClipboardTextTest	; optional - default is filename
OPT_Tmp2Asm	1		; create filename.asm
